# $Id: rsnapshot.spec,v 1.58 2008/06/28 02:10:25 djk20 Exp $

Name:		rsnapshot
Summary:	Local and remote filesystem snapshot utility
Version:	1.4.3
Release:	6.1
BuildArch:	noarch
License:	GPL
URL:		http://www.rsnapshot.org/
Group:		Productivity/Archiving/Backup
Source:		http://www.rsnapshot.org/downloads/rsnapshot-%{version}.tar.bz2
Patch0:		rsnapshot-1.4.3_config.patch
Patch1:		rsnapshot-include_dir.patch
Patch2:		rsnapshot-configure_check-lvm-cmds_1.4.2.patch
Patch3:		rsnapshot-1.4.3_config-includedir.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root

Requires:	perl rsync lvm2
BuildRequires:	rsync openssh perl coreutils util-linux lvm2 autoconf automake

%if 0%{?suse_version} <= 1020 && 0%{?suse_version} > 0
Requires:	multipath-tools
BuildRequires:	multipath-tools
%else
Requires:	kpartx
BuildRequires:	kpartx
%endif

%if 0%{?centos_version} || 0%{?fedora_version} || 0%{?rhel_version} || 0%{?sl_version}
BuildRequires:	openssh-clients
%endif

AutoReqProv:	no

%description
This is a remote backup program that uses rsync to take backup snapshots of
filesystems.  It uses hard links to save space on disk.
For more details see http://www.rsnapshot.org/.

%prep

%setup 

%patch0
%patch1
%patch2
%patch3

%build
[ -f configure ] && rm configure
autoreconf -fi

%configure					\
	--with-perl="%{__perl}"			\
	--with-rsync="%{_bindir}/rsync"		\
	--with-ssh="%{_bindir}/ssh"		\
%if 0%{?suse_version}
	--with-logger=/bin/logger		\
%endif
%if 0%{?fedora_version} || 0%{?rhel_version} || 0%{?centos_version} || 0%{?redhat_version} || 0%{?sl_version}
	--with-logger=%{_bindir}/logger		\
%endif
%if 0%{?centos_version} <= 5 && 0%{?centos_version} > 0
	--with-lvcreate="%{_sbindir}/lvcreate"	\
	--with-lvremove="%{_sbindir}/lvremove"	\
%else
%if 0%{?rhel_version} == 505
	--with-lvcreate="%{_sbindir}/lvcreate"	\
	--with-lvremove="%{_sbindir}/lvremove"	\
%else
	--with-lvcreate=/sbin/lvcreate    \
        --with-lvremove=/sbin/lvremove    \
%endif
%endif
        --with-kpartx=/sbin/kpartx        \
        --with-mount=/bin/mount           \
        --with-umount=/bin/mount          \
	--with-du="%{_bindir}/du"

%install
install -d $RPM_BUILD_ROOT/%{_bindir}
install -m 755 rsnapshot $RPM_BUILD_ROOT/usr/bin/rsnapshot 
install -m 755 rsnapshot-diff $RPM_BUILD_ROOT/usr/bin/rsnapshot-diff
install -m 755 utils/rsnapreport.pl $RPM_BUILD_ROOT/usr/bin/rsnapreport.pl

#install -d $RPM_BUILD_ROOT/%{_mandir}/man1
#install -m 644 rsnapshot*.1* $RPM_BUILD_ROOT/usr/share/man/man1/

install -d $RPM_BUILD_ROOT/%{_sysconfdir}
install -m 644 rsnapshot.conf.default $RPM_BUILD_ROOT/etc/rsnapshot.conf.default
install -m 600 rsnapshot.conf.default $RPM_BUILD_ROOT/etc/rsnapshot.conf
install -d $RPM_BUILD_ROOT/%{_sysconfdir}/rsnapshot.conf.d
install -d $RPM_BUILD_ROOT/opt/backups/lvm-snapshot

%post
#
# upgrade rsnapshot config file
#
RSNAPSHOT_CONFIG_VERSION=`%{_bindir}/rsnapshot check-config-version`
if test $? != 0; then
	echo "Error upgrading %{_sysconfdir}/rsnapshot.conf"
fi

if test "$RSNAPSHOT_CONFIG_VERSION" = "1.2"; then
	# already latest version
	exit 0
fi

if test "$RSNAPSHOT_CONFIG_VERSION" = "unknown"; then
	%{_bindir}/rsnapshot upgrade-config-file
	RETVAL=$?
	exit $RETVAL
fi
if [ -f /etc/rsnapshot.conf ] ; then
	sed -i -r s@"^linux_lvm_cmd_kpartx"@"#linux_lvm_cmd_kpartx"@g /etc/rsnapshot.conf
fi

echo "Error upgrading %{_sysconfdir}/rsnapshot.conf. Config format unknown!"
exit 1


%clean
rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_DIR/%{name}-%{version}/

%files
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog README.md
%doc docs/Upgrading_from_1.1 docs/HOWTOs/rsnapshot-HOWTO.en.html
# rsnapshot.conf.default is replaceable - user is not supposed to edit it
%config %{_sysconfdir}/rsnapshot.conf.default
%config(noreplace) %verify(user group mode) %{_sysconfdir}/rsnapshot.conf
%dir %{_sysconfdir}/rsnapshot.conf.d
%dir /opt/backups
%dir /opt/backups/lvm-snapshot
%{_bindir}/rsnapshot
%{_bindir}/rsnapshot-diff
%{_bindir}/rsnapreport.pl
## {_mandir}/man1/rsnapshot*.1*

%changelog
* Mon Jan  9 2017 cs@linux-administrator.com
- disable lvm/kpartx patch
* Mon Jan  9 2017 cs@linux-administrator.com
- update to release 1.4.2
- adapt lvm/kpartx patch to new version *cross-fingers*
* Mon Nov  7 2011 cs@linux-administrator.com
- added include_dir patch
- added lvm/kpartx snapshot patch
- added configure patch to check needed lvm commands
